package fr.shortcircuit.tp6.dao;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import org.apache.commons.collections.Predicate;

import fr.shortcircuit.tp6.model.Product;

public class ProductDAO
{
	private static List<Product> list	= new ArrayList();

	static 
	{
		//list.add(new Product(int id, String designation, int type, BigDecimal price, String genre, String realisateur, int annee, String musique, String scenario));
		
		list.add(new Product(1, "The Big Lebowsky", 1, new BigDecimal("15")));
		list.add(new Product(2, "L'enfer du dimanche", 1, new BigDecimal("10")));
		list.add(new Product(3, "American Beauty", 1, new BigDecimal("15")));
		list.add(new Product(4, "Braveheart", 1, new BigDecimal("15"), "Aventure", "Mel Gibson", 1995, "James Horner", "Randall Wallace"));
		list.add(new Product(5, "Vercingetorix", 1, new BigDecimal("15"), "Aventure", "Jack Dorfmann", 2001));
		list.add(new Product(6, "Animal Factory", 1, new BigDecimal("15"), "Policier", "Steve Buscemi", 2000));
		list.add(new Product(7, "La vie, l'amour, les vaches", 1, new BigDecimal("15"), "Comdie", "Ron Underwood", 1991));
		list.add(new Product(8, "Crossing Guard", 1, new BigDecimal("15"), "Drame", "Sean Penn", 1995));
		list.add(new Product(9, "Tigres et dragons", 1, new BigDecimal("15"), "Aventure", "Ang Lee", 2000));
		list.add(new Product(10, "Swimming with sharks", 1, new BigDecimal("25"), "Drame", "G. Huang", 1995));
		list.add(new Product(11, "Les grands ducs", 1, new BigDecimal("20"), "Comdie", "Patrice Leconte", 1995, "Jean-Claude Nachon, Anglique Nachon", "Patrice Leconte, S. Frydman"));
		list.add(new Product(12, "Sling Blade", 1, new BigDecimal("20"), "Drame", "Billy Bob Thornton", 1997));
		list.add(new Product(13, "Magnolia", 1, new BigDecimal("20"), "Drame", "Paul Thomas Anderson", 1999));
		list.add(new Product(14, "Exit", 1, new BigDecimal("20"), "Policier", "Olivier Megaton", 2000));
		list.add(new Product(15, "X-Men", 1, new BigDecimal("20"), "Fantastique", "Bryan Singer", 2000));
		list.add(new Product(16, "The Yards", 1, new BigDecimal("25"), "Policier", "James Gray", 2000));
		list.add(new Product(17, "O'Brother", 1, new BigDecimal("25"), "Comdie", "Joel Cohen, Ethan Cohen", 2000));
		list.add(new Product(18, "Les mutants de l'espace", 1, new BigDecimal("15"), "Film d'animation", "Bill Plympton", 2001));
		list.add(new Product(19, "High Fidelity", 1, new BigDecimal("10"), "Comdie", "Stephen Frears", 2000));
		list.add(new Product(20, "Trainspotting", 1, new BigDecimal("10"), "Drame", "Danny Boyle", 1996));
		list.add(new Product(21, "La ligne Verte", 1, new BigDecimal("10"), "Drame", "Frank Darambont", 1999, "Thomas Newman", "Frank Darambont"));
		list.add(new Product(22, "Predator 2", 1, new BigDecimal("10"), "Fantastique", "Stephen Hopkins", 1990));    
		list.add(new Product(23, "Fist of Legend", 1, new BigDecimal("15"), "Action", "Gordon Chan", 1994, "Joseph Koo", "Gordon Chan, Lan Kay Toa"));
		list.add(new Product(24, "En territoire ennemi", 1, new BigDecimal("20"), "Guerre", "John Moore", 2001, "Don Davis", "Jim Thomas, John  Thomas, David Veloz, Zak Penn"));
		list.add(new Product(25, "Monique", 1, new BigDecimal("25"), "Comdie", "Valrie Guignabodet", 2002, "Cdric Neveux", "Valrie Guignabodet"));
		list.add(new Product(26, "Une affaire de got", 1, new BigDecimal("15"), "Drame", "Bernard Rapp", 1999));
		list.add(new Product(27, "Cecil B. DeMented", 1, new BigDecimal("25"), "Comdie", "John Waters", 2000));
		list.add(new Product(28, "Abyss", 1, new BigDecimal("25"), "Fantastique", "James Cameron", 1989));
		list.add(new Product(29, "Ghost World", 1, new BigDecimal("15"), "Comdie", "Terry Zwigoff", 2001));
		list.add(new Product(30, "Les Autres", 1, new BigDecimal("20"), "Fantastique", "Alejandro Amenabar", 2001));
		list.add(new Product(31, "The Big One", 1, new BigDecimal("20"), "Documentaire", "Michael Moore", 1999));
		list.add(new Product(32, "Ocean's Eleven", 1, new BigDecimal("15"), "Suspense", "Steven Soderbergh", 2001));
		list.add(new Product(33, "La ranon", 1, new BigDecimal("15"), "Suspense", "Ron Howard", 1996));
		list.add(new Product(34, "La plage", 1, new BigDecimal("15"), "Aventure", "Danny Boyle", 1999));
		list.add(new Product(35, "Barton Fink", 1, new BigDecimal("15"), "Comdie Dramatique", "Joel et Ethan Cohen", 1991));
		list.add(new Product(36, "Little Buddha", 1, new BigDecimal("15"), "Comdie Dramatique", "Bernardo Bertolucci", 1993, "Ryuichi Sakamoto", "Bernardo Bertolucci, Mark Peploe"));                  
	}


	public Product getProduct(Predicate predicate)
	{
        for (Product product : list)
        	if (predicate.evaluate(product))
        	{
        		System.out.println("ProductDAO: getProduct: find " + product);
        		
        		return product;
        	}

		return null;
	}

	public List<Product> getAllProduct(Comparator beanComparator)
	{
		Collections.sort(list, beanComparator);              
		
		return list;
	}

	/**
	 * Cette mthode etend la precedente, elle permet de selectionner une portion de la liste en fonction de l'index et de la quantite passe en plus en parametre
	 * ces parametres peuvent etre delegues dans une requete SQL afin de remonter qu'un subset de donnes, et non la totalit d'une table :)
	 * 
	 * @param beanComparator
	 * @param rowIndex
	 * @param rowCount
	 * @return
	 */
	public List<Product> getAllProduct(Comparator beanComparator, int rowIndex, int rowCount)
	{
		Collections.sort(list, beanComparator);
		
		return list.subList(rowIndex, rowCount);
	}

}
