package fr.shortcircuit.tp6.web;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.faces.component.html.HtmlDataTable;

import org.apache.commons.beanutils.BeanComparator;
import org.apache.commons.beanutils.BeanPredicate;
import org.apache.commons.collections.Predicate;
import org.apache.commons.collections.comparators.ReverseComparator;
import org.apache.commons.collections.functors.AllPredicate;
import org.apache.commons.collections.functors.EqualPredicate;

import fr.shortcircuit.tp6.business.ProductBO;
import fr.shortcircuit.tp6.model.Product;
import fr.shortcircuit.tp6.web.util.KeyRepository;


public class ProductBean
{
	//Injected references
	private ProductBO 				productBO;
	private ProductEditBean 		productEditBean;
	private KeyRepository 			keyRepository;
	
	//Page variables
	private HtmlDataTable 			dataTable;
	private String 					sortColumn 		= "id";
    private int                		rowCount       	= 10;
	private boolean 				sortAscending;
	
	//temp
	private Date					date;
	
	
	
	public ProductBean()
	{
		
	}
	
	/**
	 * 
	 * @return
	 */
	public List<Product> getAllProduct()
	{
		//return productBO.getAllProduct((sortAscending)? new BeanComparator(sortColumn) : new ReverseComparator(new BeanComparator(sortColumn)), dataTable.getRowIndex(), rowCount);		
		return productBO.getAllProduct((sortAscending)? new BeanComparator(sortColumn) : new ReverseComparator(new BeanComparator(sortColumn)));
	}
	
	public String searchProduct()
	{
		ArrayList<Predicate> listPredicate  = new ArrayList();

		listPredicate.add(new BeanPredicate("id", new EqualPredicate(((Product) dataTable.getRowData()).getId())));

		Predicate pAll                      =  new AllPredicate((Predicate[]) listPredicate.toArray(new Predicate[] {})); //AnyPredicate
		
		productEditBean.setCurrentProduct(productBO.getProduct(pAll)); 
		productEditBean.setStateDisplayValueOnly(true);
		
		return "productEdit";
	}

	public ProductBO getProductBO()										{return productBO;}
	public HtmlDataTable getDataTable()									{return dataTable;}
	public String getSortColumn()										{return sortColumn;}
	public boolean isSortAscending()									{return sortAscending;}
	public ProductEditBean getProductEditBean()							{return productEditBean;}
	public int getRowCount()											{return rowCount;}
	public Date getDate()												{return date;}
	public KeyRepository getKeyRepository()								{return keyRepository;}

	public void setProductBO(ProductBO productBO)						{this.productBO 		= productBO;}
	public void setDataTable(HtmlDataTable dataTable)					{this.dataTable 		= dataTable;}
	public void setSortColumn(String sortColumn)						{this.sortColumn 		= sortColumn;}
	public void setSortAscending(boolean sortAscending)					{this.sortAscending 	= sortAscending;}
	public void setProductEditBean(ProductEditBean productEditBean)		{this.productEditBean 	= productEditBean;}
	public void setRowCount(int rowCount)								{this.rowCount 			= rowCount;}
	public void setDate(Date date)										{this.date 				= date;}
	public void setKeyRepository(KeyRepository keyRepository)			{this.keyRepository 	= keyRepository;}
	 
}
