package fr.shortcircuit.tp6.web;

import javax.faces.application.FacesMessage;

import fr.shortcircuit.tp6.business.ProductBO;
import fr.shortcircuit.tp6.model.Product;
import fr.shortcircuit.tp6.web.util.KeyRepository;
import fr.shortcircuit.tp6.web.util.WebHelper;

public class ProductEditBean
{
	//Injected references
	private ProductBO 				productBO;
	private KeyRepository 			keyRepository;
	
	//Session Associated references
	private Product					currentProduct;
	
	private boolean 				stateDisplayValueOnly = true;
	
	
	public ProductEditBean()
	{
		
	}
	
	public void editProduct()
	{
		stateDisplayValueOnly = false;
	}
	
	public void saveProduct()
	{
		stateDisplayValueOnly = true;
		
		//ici on doit normalement invoquer l'enregistrement de l'objet par le BO
		
		WebHelper.addMessageFromBundle(keyRepository.getResourceBundle(), "message.save.ok", "Enregistrement OK", FacesMessage.SEVERITY_INFO);
	}
	
	public ProductBO getProductBO()											{return productBO;}
	public Product getCurrentProduct()										{return currentProduct;}
	public boolean isStateDisplayValueOnly()								{return stateDisplayValueOnly;}
	public KeyRepository getKeyRepository()									{return keyRepository;}

	public void setProductBO(ProductBO productBO)							{this.productBO 				= productBO;}
	public void setCurrentProduct(Product currentProduct)					{this.currentProduct 			= currentProduct;}
	public void setStateDisplayValueOnly(boolean stateDisplayValueOnly)		{this.stateDisplayValueOnly 	= stateDisplayValueOnly;}
	public void setKeyRepository(KeyRepository keyRepository)				{this.keyRepository 			= keyRepository;}

}
